#pragma once
#include <windows.h>
#include "Trekant.h"
#include "Edge.h"
#include "vek3.h"
#include "Triangle.h"
#include <stdio.h>
#include <gl/gl.h>
#include <gl/glut.h>
#include <math.h>

inline double dist(Point3D a, Point3D b)
{
	Vektor3D v = a-b;
	return sqrt(v.d[0]*v.d[0] + v.d[1]*v.d[1] + v.d[2]*v.d[2]);
}

class Object3D
{
public:
	Object3D(void);
	~Object3D(void);

	Trekant**t;
	Edge**e;
	Point3D**p;
	int nt, ne, np;
	void generer(Triangle **liste, int ant);
	void tegn();
	int MODE;
	static int POINT, WIRE, SOLID;
	int FinnPunkt(Point3D *test);

	int leggTilPunkt(Point3D *p);
	int leggTilEdge(Edge *en);
	int leggTilTrekant(Trekant *t);

	int maxp, maxe, maxt;
};
