#pragma once
#include <gl/glut.h>
#include "Object3D.h"
#include "MatriseBib.h"

class ParticleSystem
{
public:
	ParticleSystem(void);
public:
	~ParticleSystem(void);

public:
	int nn;
static double dt;
	void UpdateSim(float fStep);
	void beregnKrefter();
	void beregnPosisjon();
	int teller;
	void test();
	SMatrise filter(SMatrise &a);
	Array filter(Array &a);
	void filter(Array &, Array &);
	bool CGSolver(Array &dv, SMatrise&A, Array &b, int antall);
	void Jacobi(Array &dv, SMatrise&A, Array &b, int n);
	void lagP(SMatrise &P, SMatrise &P1, SMatrise &);
	void init();
	SMatrise K, SS, L, A, I;
	IMatrise M1;
	Vektor3D g;
	Array F, FExt, v0, p0, v1, dv, n;
	Object3D obj;
	void LagLaken();
	void filtrer(Array &a);

	double vekt;
	double tiden;
	
private: // Hjelpematriser til cgsolver
	Array r, bFilTPb, PbFil, Adv;
	Array q, s, P1r, bAdv, bFil, c;
	
	SMatrise P, P1;
	inline void initHjelp();

	SMatrise dtL, dtdtK, LM, KM, LminusK;
	Array b, dtv0, dtKv0, FdtKv0;
	SMatrise dtK;

};
