#pragma once

class Edge
{
public:
	Edge(int p0, int p1, int t0, int t1, int lel, int ler, int nel, int ner, double dist);
	~Edge(void);
	double rest;
	int e[4];
	int p[2];
	int t[2];
	int type;
	static double KS, KD;
	static int TYPE;
	static double STRETCH_KS, STRETCH_KD, BEND_KS, BEND_KD, SHEAR_KS, SHEAR_KD, FAKTOR;
	enum { STRETCH, BEND, SHEAR } typer;
	inline double getKS()
	{ 
		switch(type)
		{
		case STRETCH:
			return STRETCH_KS;
		case BEND:
			return BEND_KS;
		case SHEAR:
			return SHEAR_KS;
		default:
			return 0;
		}
	}
	inline double getKD()
	{ 
		switch(type)
		{
		case STRETCH:
			return STRETCH_KD;
		case BEND:
			return BEND_KD;
		case SHEAR:
			return SHEAR_KD;
		default:
			return 0;
		}
	}
private:
	
};
