#pragma once 
#include "MatriseBib.h"
#include <math.h>
static int deleVerdi = 2, minIt = 10, maksIt = 100;
static IMatrise P, P1;
static Array PbFil, Adv, bFilTPb, r, c, s, q, P1r, bAdv, bFil;
inline void lagP(IMatrise &Pa, IMatrise &Pa1, SMatrise &A)
{
	//// printf("Er i LagP\n");
	for(int i = 0; i < A.r; i++)
	{
		
		for(int j = 0; j < 3; j++)
		{
			Pa(i*3+j) = 1/A(i, i).d[j][j];
			Pa1(i*3+j) = A(i, i).d[j][j];
				
			
		}
		// P1(i, i) = A(i, i).inverse();
	}	
	//// printf("ER ferdig i lagP\n");
}
inline void filtrer(Array &a)
{
	for(int i = 0; i < 3*deleVerdi; i++) a(i) = 0;
}
inline void filter(Array &res, Array &a)
{
	for(int i = 0; i < 3*16; i++)
	{
		res(i) = (i < 3*deleVerdi ? 0 : a(i));
	}
}
inline void initHjelp(int n)
{
	P.Endre(3*n);
	P1.Endre(3*n);
	PbFil.Endre(3*n);
	Adv.Endre(3*n);
	bFilTPb.Endre(3*n);
	r.Endre(3*n);
	c.Endre(3*n);
	s.Endre(3*n);
	q.Endre(3*n);
	
	
	
	P1r.Endre(3*n);
	bAdv.Endre(3*n);
	bFil.Endre(3*n);
	deleVerdi = n;
	// SMatrise dtL, dtdtK, LM, KM, LminusK;
	
	
	

	

}
inline bool CGSolverTest(Array &dv, SMatrise &A, Array &b)
{
	//// printf("ER kommet til testen CGSOlver\n");
	int tid[1000];
	//tid[0] = 1;
	int indeks = 0;
	//// printf("Er kommet til CGSolver\n");
	
	//P.NullStill(); P1.NullStill();
	lagP(P, P1, A);
	
	
	
	// sigmaNull = filter(b)T*P*filter(b)
	
	filter(bFil, b);
	
	mul(PbFil, P, bFil);
	float sigmaNull;
	mul(sigmaNull, bFil, PbFil);

	
	// r = b-A*dv
	
	mul(Adv, A, dv); // Adv = prod(A, dv);
	minus(bAdv, b, Adv); // bAdv = b - Adv;
	
	filter(r, bAdv); // r = filter(bAdv);
	


	// c = filter(P1*r)
	
	mul(P1r, P1, r); // P1r = prod(P1, r);
	
	filter(c, P1r);

	
	// sigmaNy = rT*c
	float sigmaNy;
	mul(sigmaNy, r, c); // double sigmaNy = (prod(trans(r), c))(0, 0);
	
	double liten = 0.00001;//

	int it = 0;
	//// printf("Skal begynne p lkken %lf, %lf %lf\n", liten, sigmaNy, sigmaNull);
	
		
	// printf("sigmaNy = %lf, sigmaNull = %lf\n", sigmaNy, sigmaNull);
	indeks = 0;
	tid[1] = 1;
	int maxIt = (int)sqrt((double)16)*3 + 3;
	maxIt = 10;
	
	//maxIt = maxIt << 2;
	while(indeks < maxIt) 
	{
		//if(indeks % 10 == 0)
		{
			//if(sigmaNy <= liten * sigmaNull) break;
		}
		indeks++;

		
		it++;//indeks++;
		//if(indeks == 3) // printf("sigmaNy=%lf\n", sigmaNy);
		//if(indeks == 3) c.skrivTilFil("C.txt");
		// q = filter(A*c)
		//Array qTemp(3*16);
		mul(q, A, c);
		filter(q, q);
		//if(indeks == 3) q.skrivTilFil("Q.txt");

		// alfa = sigmaNy/(cT*q)
		float alfa;
		mul(alfa, c, q); 
		alfa = sigmaNy / alfa;
		//if(indeks == 3) // printf("alfa=%lf\n", alfa);

		// dv = dv + alfa*c
		// if(indeks == 3) dv.skrivTilFil("DV1.txt");
		for(int i = 0; i < dv.l; i++) // dv += alfa * c;
		{
			dv(i) += alfa * c(i);
		}
		//if(indeks == 3) dv.skrivTilFil("DV2.txt");


		// r = r - alfa*q
		//if(indeks == 3) r.skrivTilFil("R1.txt");
		for(int i = 0; i < r.l; i++) // r -= alfa * q;
		{
			
			r(i) -= alfa * q(i);
		}
		//if(indeks == 3) r.skrivTilFil("R2.txt");
		

		// s = P1*r
		mul(s, P1, r);
		//if(indeks==3) s.skrivTilFil("S.txt");

		// sigmaOld = sigmaNy
		float sigmaOld = sigmaNy;

		
		// sigmaNy = rT*s
		mul(sigmaNy, r, s); // sigmaNy = (prod(trans(r), s))(0, 0);
		//if(indeks == 3) // printf("ny sigmaNy = %lf\n", sigmaNy);
		
		// c = filter(s + sigmaNy/sigmaOld * c)
		mul(c, c, (sigmaNy/sigmaOld));
		sum(c, s, c); // = s + (sigmaNy/sigmaOld)*c;
		filter(c, c);
		//if(indeks == 3) c.skrivTilFil("CNY.txt");
		//tid[1+it] = 1;
		//// printf("sigmaNy = %lf\n", sigmaNy);
		
	}
// printf("Det ble kjrt %d iterasjoner\n", indeks);
// printf("Ferdig i CG-testen\n");
	#ifdef KDEBUG
	// printf("Det ble kjrt %d iterasjoner\n", indeks);
	
	/*if(indeks == 1)
	{
		// printf("Det skjedde noe merkelig\n");
		// getchar();
	}*/
	// printf("Brukte %d iterasjoner\n", indeks);
	#endif
	filter(dv, dv);
	return (indeks < maxIt) && (indeks > minIt);
}

inline void beregnF(double &fx, double &fy, double &fz, double xx, double xy, double xz, double vx, double vy, double vz, double ks, double kd, double rest)
{
	// Fi = -(ks*(vL - rest) +  kd(L*L'/vL))*v / vL
	double len = sqrt(xx*xx+xy*xy+xz*xz);
	double dott = (xx*vx+xy*vy+xz*vz)/len;

	fx = -(ks*(len-rest)+kd*dott)*xx/len;
	fy = -(ks*(len-rest)+kd*dott)*xy/len;
	fz = -(ks*(len-rest)+kd*dott)*xz/len;
}

inline void beregnDFDX(Matrix3x3 &m, double xx, double xy, double xz, double vx, double vy, double vz, double ks, double kd, double rest)
{
	double len = sqrt(xx*xx+xy*xy+xz*xz);
	double oneovernorm = 1/len;
	double oneovercubed = oneovernorm*oneovernorm*oneovernorm;
	double dotvv = xx*xx+xy*xy+xz*xz;
	double dotfv = xx*vx+xy*vy+xz*vz;
	// -ks*(dcdx*dcdxT +d2*C)-kd*(d2*C_dot)
	// dcdx = v / len
	double dcdx[3]; 
	dcdx[0] = xx / len;
	dcdx[1] = xy / len;
	dcdx[2] = xz / len;

	// d2 = dot(v, v) * oneovercubed - oneovernorm
	double d2 = dotvv * oneovercubed - oneovernorm;

	// C = len - rest
	double C = len - rest;

	// C_dit = dcdx * fv
	double C_dot = dcdx[0] * vx + dcdx[1] * vy + dcdx[2] * vz;


	m.d[0][0] = -ks * (-dcdx[0]*dcdx[0] + d2 * C) - kd * (d2 * C_dot);
	m.d[0][1] = -ks * (-dcdx[0]*dcdx[1] + d2 * C);
	m.d[0][2] = -ks * (-dcdx[0]*dcdx[2] + d2 * C);

	m.d[1][0] = -ks * (-dcdx[1]*dcdx[0] + d2 * C);
	m.d[1][1] = -ks * (-dcdx[1]*dcdx[1] + d2 * C) - kd * (d2 * C_dot);
	m.d[1][2] = -ks * (-dcdx[1]*dcdx[2] + d2 * C);

	m.d[2][0] = -ks * (-dcdx[2]*dcdx[0] + d2 * C);
	m.d[2][1] = -ks * (-dcdx[2]*dcdx[1] + d2 * C);
	m.d[2][2] = -ks * (-dcdx[2]*dcdx[2] + d2 * C) - kd * (d2 * C_dot);
	// printf("ks(%lf), dcdx(%lf, %lf, %lf)\n", ks, dcdx[0], dcdx[1], dcdx[2]);
}
inline void beregnKrefteneCPU(Array &F, SMatrise &dfdx, Array &P0, Array &V0, double ks, double kd, int w, int h)
{
#define MAX(a, b) (a < b ? b : a)
#define MIN(a, b) (a < b ? a : b)
	
	for(int i = 0; i < h; i++)
	{
		for(int j = 0; j < w; j++)
		{
			F(3*(i*w+j)+0) = 0;
			F(3*(i*w+j)+1) = 0;
			F(3*(i*w+j)+2) = 9.81;

			for(int ii = MAX(i-2, 0); ii <= MIN(i+2, h-1); ii++)
			{
				for(int jj = MAX(j-2, 0); jj <= MIN(j+2, w-1); jj++)
				{
					if(ii == i && jj == j) continue;
					
					double rx = i-ii;
					double ry = j-jj;
					double r = sqrt(rx*rx + ry*ry);
					// Skal legge til kreftene som virker mellom (i, j) og (ii, jj)
					double fx, fy, fz;
					beregnF(fx, fy, fz, 
							P0(3*(i*w+j)+0) - P0(3*(ii*w+jj)+0), 
							P0(3*(i*w+j)+1) - P0(3*(ii*w+jj)+1), 
							P0(3*(i*w+j)+2) - P0(3*(ii*w+jj)+2), 
							V0(3*(i*w+j)+0) - V0(3*(ii*w+jj)+0), 
							V0(3*(i*w+j)+1) - V0(3*(ii*w+jj)+1), 
							V0(3*(i*w+j)+2) - V0(3*(ii*w+jj)+2), 
							ks, kd, 
							r);

					F(3*(i*w+j)+0) += fx;
					F(3*(i*w+j)+1) += fy;
					F(3*(i*w+j)+2) += fz;
					//continue;
					Matrix3x3 m;
					beregnDFDX(m, 
							P0(3*(i*w+j)+0) - P0(3*(ii*w+jj)+0), 
							P0(3*(i*w+j)+1) - P0(3*(ii*w+jj)+1), 
							P0(3*(i*w+j)+2) - P0(3*(ii*w+jj)+2), 
							V0(3*(i*w+j)+0) - V0(3*(ii*w+jj)+0), 
							V0(3*(i*w+j)+1) - V0(3*(ii*w+jj)+1), 
							V0(3*(i*w+j)+2) - V0(3*(ii*w+jj)+2), 
							ks, kd, 
							r);

					int xpos = ii*w+jj;
					int ypos = i*w+j;
					dfdx(xpos, ypos) = m;
					//dfdx(ypos, xpos) = m;

					for(int k0 = 0; k0 < 3; k0++)
					{
						for(int k1 = 0; k1 < 3; k1++)
						{
							dfdx(xpos, xpos).d[k0][k1] -= m.d[k0][k1];
							//dfdx(ypos, xpos).d[k0][k1] -= m.d[k0][k1];
						}
					}
					
					

				}
			}
		}
	}
	
}